<?php

// timer start
$_st = microtime();

// input filtering
require( 'lib/baselib/inputfilter.inc.php' );

// initialize and load module
require( 'init.inc.php' );

// register start time
diff_time( $_st );

// default view
$get =& Request::getInstance( '_GET' );
$mode = $get->get( 'mode' );
if ( ! $mode ) {
	$view =& new View();
	$view->addItems();
	$view->display( 'default' );
	exit;
}
if ( $mode === 'rss' ) {
	$view =& new View();
	$view->addItems();
	$view->display( 'rss' );
	exit;
}

// is authentication
$conf =& Config::getInstance();
if ( ! $conf->isAuth() ) {
	include( VIEW_DIR . 'error_auth.tpl.php' );
	exit;
}
// include command module and fileter module
require( LIBS_DIR . 'command.inc.php' );
require( LIBS_DIR . 'filters.inc.php' );
$filters =& Filters::getInstance( $filter_file );

// measures against CSRF
if ( $conf->isCsrf() ) {
	Command::redirect();
	exit;
}
else {
	$conf->createUniqID();
}
$post =& Request::getInstance( '_POST' );

switch ( $mode ) {
case 'config' :
	if ( ! $post->get() ) {
		$view =& new View();
		$view->display( 'config' );
		exit;
	}
	switch ( TRUE ) {
	case $post->is_set( 'chpass' ) :
		$user   = $post->get( 'user',  '' );
		$pass1  = $post->get( 'pass1', '' );
		$pass2  = $post->get( 'pass2', '' );
		$result = Command::changePass( $user, $pass1, $pass2 );
		Command::redirect( '?mode=config&c=p', $result );
		exit;

	case $post->is_set( 'setproxy' ) :
		$use_proxy = $post->get( 'use_proxy' );
		$proxy     = $post->get( 'proxy', '' );
		$result    = Command::setProxy( $use_proxy, $proxy );
		Command::redirect( '?mode=config&c=n', $result[0], array( $result[1], $result[2] ) );
		exit;

	case $post->is_set( 'addcategory' ) :
		$result = Command::addCategory( $post->get( 'name' ) );
		Command::redirect( '?mode=config&c=c', $result[0], array( $result[1] ) );
		exit;

	case $post->is_set( 'delcategory' ) :
		$result = Command::delCategory( $post->get( 'id' ) );
		Command::redirect( '?mode=config&c=c', $result[0], array( $result[1] ) );
		exit;

	case $post->is_set( 'altercategory' ) :
		$id     = $post->get( 'id'   );
		$name   = $post->get( 'name' );
		$result = Command::alterCategory( $id, $name );
		Command::redirect( '?mode=config&c=c', $result[0], array( $result[1], $result[2] ) );
		exit;

	case $post->is_set( 'upcategory' ) :
		$result = Command::upCategory( $post->get( 'id' ) );
		Command::redirect( '?mode=config&c=c', $result[0], array( $result[1] ) );
		exit;

	case $post->is_set( 'downcategory' ) :
		$result = Command::downCategory( $post->get( 'id' ) );
		Command::redirect( '?mode=config&c=c', $result[0], array( $result[1] ) );
		exit;

	case $post->is_set( 'additem' ) :
		$result = Command::addItem( $post->get( 'additem' ) );
		if ( substr( $result[0], 0, 5 ) !== 'ERROR' ) {
			Command::redirect( '?cat=No&lim=0', $result[0], array( $result[1], $result[2] ) );
		}
		Command::redirect( '?mode=config', $result[0], array( $result[1], $result[2] ) );
		exit;

	case $post->is_set( 'defaultsetting' ) :
		$array = array(
			'title'      => $post->get( 'title' ),
			'css'        => $post->get( 'css', '' ),
			'diff_count' => (int)$post->get( 'diff_count', 200 ),
			'lim'        => (int)$post->get( 'lim', 0 ),
			'vis'        => (bool)$post->get( 'vis', TRUE ),
		);
		$result = Command::setConfig( $array );
		Command::redirect( '?mode=config&c=d', $result );
		exit;

	case $post->is_set( 'commandpath' ) :
		$php_command  = $post->get( 'php_command',  '' );
		$diff_command = $post->get( 'diff_command', '' );
		if ( strtoupper( substr( PHP_OS, 0, 3 ) ) === 'WIN' ) {
			$php_command  = strtr( $php_command,  '\\', '/' );
			$diff_command = strtr( $diff_command, '\\', '/' );
		}
		$array = array(
			'php_command'  => is_executable( $php_command  ) ? $php_command  : '',
			'diff_command' => is_executable( $diff_command ) ? $diff_command : ''
		);
		$result = Command::setConfig( $array );
		Command::redirect( '?mode=config&c=e', $result );
		exit;
	}
	Command::redirect( '?mode=config', ifsetor( $result, '' ) );
	exit;

case 'setting' :
	switch ( TRUE ) {
	case $post->is_set( 'setting' ) :

		$uri = $post->get( 'setting' );
		switch ( TRUE ) {
		case $post->is_set( 'alter' ) :
			$arr = array(
				'to_uri'   => $post->get( 'to_uri',   '' ),
				'title'    => $post->get( 'title',    '' ),
				'open_uri' => $post->get( 'open_uri', '' ),
				'count'    => $post->get( 'count',    '' ),
				'category' => $post->get( 'category', '' ),
				'encoding' => $post->get( 'encoding', '' )
			);
			$result = Command::alterItem( $uri, $arr );
			Command::redirect( '?mode=setting&uri=' . u( $result[1] ), $result[0], array( $result[1] ) );
			exit;

		case $post->is_set( 'delete' ) :
			$result = Command::deleteItem( $uri );
			Command::redirect( '', $result[0], array( $result[1] ) );
			exit;
		}

	case $get->is_set( 'update' ) :
		$result = Command::updateItem( $get->get( 'update', '' ) );
		Command::redirect( '?mode=setting&uri=' . u( $result[1] ), $result[0], array( $result[1], $result[2] ) );
		exit;
	}
	$view  =& new View();
	$uri    = $get->get( 'uri', '' );
	$result = $view->addItems( $uri );
	if ( $result ) {
		$view->display( 'setting' );
		exit;
	}
	Command::redirect( '', 'ERROR_NOT_FILE', array( $uri ) );
	exit;

case 'status' :
	$get->set( 'sort', '_NO_ORDER' );
	$get->set( 'lim', 0 );
	$get->set( 'vis', FALSE );
	$view =& new View();
	$view->addItems();
	$view->display( 'status' );
	exit;

case 'filter' :
	$command = '';
	switch ( TRUE ) {
	case $post->is_set( 'addfilter' ) : $command = 'add'; break;
	case $post->is_set( 'delfilter' ) : $command = 'del'; break;
	}
	if ( $command ) {
		$uri = $post->get( 'uri', '' );
		$pat = $post->get( 'pat', '' );
		$result = $filters->$command( $uri, $pat );
		Command::redirect( '?mode=filter', $result );
		exit;
	}
	$view =& new View();
	$view->display( 'filter' );
	exit;
}
Command::redirect();
exit;
