<?php

define( 'TOOL_NAME',    'wwwcheck.php' );
define( 'TOOL_VERSION', '0.5' );

umask( 0070 );
ob_implicit_flush( 0 );

ini_set( 'display_errors', 0 );
error_reporting( E_ALL );

$self_dir    = dirname( __FILE__ ) . '/';
$conf_file   = $self_dir . 'data/config.dat.php';
$cate_file   = $self_dir . 'data/categories.dat.php';
$count_file  = $self_dir . 'data/count.dat.php';
$filter_file = $self_dir . 'data/filters.dat.php';

require( $self_dir . 'lib/data.inc.php' );
require( $self_dir . 'lib/item.inc.php' );
require( $self_dir . 'lib/view.inc.php' );
require( $self_dir . 'lib/baselib/category.inc.php'  );
require( $self_dir . 'lib/baselib/config.inc.php'    );
require( $self_dir . 'lib/baselib/functions.inc.php' );
require( $self_dir . 'lib/baselib/encoding.inc.php'  );
require( $self_dir . 'lib/baselib/validate.inc.php'  );
require( $self_dir . 'lib/baselib/request.inc.php'   );
// require( $self_dir . 'lib/baselib/compat.inc.php'    );

define( 'WEB_SELF', dirname( $_SERVER['SCRIPT_NAME'] ) . '/' );
define( 'SELF_DIR', $self_dir );
define( 'LIBS_DIR', $self_dir . 'lib/'  );
define( 'VIEW_DIR', $self_dir . 'view/' );
define( 'TEMP_DIR', $self_dir . 'data/temp/' );
define( 'ITEM_DIR', $self_dir . 'data/item/' );
define( 'LOGS_DIR', $self_dir . 'data/log/'  );

define( 'SAVE_HANDLE', 'File' );	// (File|SQLite|PEAR_DB) : data save handler
if ( SAVE_HANDLE === 'PEAR_DB' ) {
	define( 'DSN', 'pgsql://user:pass@unix()/wwwcheck' );
//	define( 'DSN', 'sqlite:///' . ITEM_DIR . 'data.sqlite?mode=0606' );
}

// prepare configuration object
$conf =& Config::getInstance( $conf_file );
if ( ! is_object( $conf ) ) {
	// first access : setting default values
	include( $self_dir . 'misc/default_setting.inc.php' );
}

// count and go URI.
if ( isset( $_GET['go'] ) ) {
	Item::redirect( $_GET['go'] );
}

// prepare encodings object
Encodings::getInstance(
	$conf->get( 'mb_encoding',  'uni' ),
	$conf->get( 'mb_enc_order', 'ASCII, JIS, UTF-8, EUC-JP, eucJP-win, SJIS, SJIS-win, ISO-8859-1' )
);
Request::getInstance( '_GET',    $_GET  );
Request::getInstance( '_POST',   $_POST );
// Request::getInstance( '_SERVER', $_SERVER );

// prepare categories object
Category::getInstance( $cate_file );

unset( $_FILES, $_COOKIE, $_ENV, $_REQUEST, $_GET, $_POST );
