<?php

class Data
{
	function &getReader( $handler )
	{
		static $reader = NULL;

		if ( $reader === NULL ) {
			$datadir = Data::loadModule( 'reader', $handler );
			$handler = 'DataReader_' . $handler;
			$reader  = new $handler( $datadir );
		}
		return $reader;
	}

	function &getWriter( $handler, $uri )
	{
		static $writer = NULL;

		if ( $writer === NULL ) {
			$datadir = Data::loadModule( 'writer', $handler );
			$handler = 'DataWriter_' . $handler;
			$writer  = new $handler( $datadir, $uri );
		}
		else {
			$writer->setUri( $uri );
		}
		return $writer;
	}

	function loadModule( $module, $handler )
	{
		$conf =& Config::getInstance();

		$name = strtolower( $handler );
		$file = dirname( __FILE__ ) . '/data/' . $module . '_' . $name . '.inc.php';

		if ( is_file( $file ) ) {
			require_once( $file );
		}
		else {
			exit( h( 'cannot load module: ' . $module . '/' . $name ) );
		}
		$datadir = ( $handler === 'PEAR_DB' ) ? DSN : ITEM_DIR;
		return $datadir;
	}
}
