<?php

class DataReader_DB
{
	var $db;

	function getItems( $uris = '' )
	{
		if ( $uris ) {
			$uris  = $this->db->escapeSimple( $uris );
			$table = $this->db->getAll( "SELECT * FROM wwwcheck WHERE uri = '" . $uris . "'" );
		}
		else {
			$where = $this->getWhere();
			$order = $this->getOrder();
			$table = $this->db->getAll( 'SELECT * FROM wwwcheck ' . $where . $order );

			$conf =& Config::getInstance();
			if ( $conf->get( 'count' ) === FALSE ) {
				$count = $this->db->getOne( 'SELECT count(uri) as count FROM wwwcheck' );
				$conf->set( 'count', $count );
			}
		}
		if ( DB::isError( $table ) ) {
			return array();
		}
		return $table;
	}

	function getList()
	{
		return array_map(
			create_function( '$a', 'return $a["uri"];' ),
			$this->db->getAll( 'SELECT uri FROM wwwcheck' )
		);
	}

	function getOrder()
	{
		$get  =& Request::getInstance( '_GET' );
		$sort  = $get->get( 'sort' );
		switch ( $sort ) {
		case 'last_modified'  :
		case 'uri'   :
		case 'size'  :
		case 'title' :
		case 'count' :
		case 'last_visit' :
			$rev = $get->get( 'rev' );
			break;
		case '_NO_ORDER' :
			return '';
		default      :
			$get->set( 'rev',  $rev  = TRUE );
			$get->set( 'sort', $sort = 'last_modified' );
		}
		return ' ORDER BY ' . $sort . ( $rev ? ( ' DESC' ) : '' );
	}

	function getWhere()
	{
		$get  =& Request::getInstance( '_GET' );

		$where    = array();
		$category = $get->get( 'cat' );
		$visit    = $get->get( 'vis' );
		$limit    = $get->get( 'lim', 24 );

		// Filtering by category
		if ( $category !== FALSE && $category !== '' ) {
			$where[] = 'category = ' . ( $category === 'No' ? "''" : (int)$category );
		}
		// Display item in limit time.
		if ( $limit ) {
			$where[] = 'last_modified >= ' . ( time() - (int)$limit * 3600 );
		}
		// Hide visited page after check time
		if ( $visit ) {
			$where[] = 'last_modified >= last_visit';
		}
		return $where ? ( 'WHERE ' . implode( ' AND ', $where ) ) : '';
	}
}
