<?php

class DataReader_File
{
	var $datadir;

	function DataReader_File( $datadir )
	{
		$this->datadir = $datadir;
	}

	function getItems( $uris = '' )
	{
		$table = array();

		if ( $uris ) {
			$info = load_config( $this->datadir . u( $uris ) );
			if ( is_array( $info ) ) {
				$table[] = $info;
			}
		}
		else {
			$uris = $this->getList();
			$get =& Request::getInstance( '_GET' );
			$get->set( 'cnt', count( $uris ) );

			$category = $get->get( 'cat', '' );
			$limit    = $get->get( 'lim', 24 );
			$vis      = $get->get( 'vis' );
			if ( $limit ) {
				$lim_time = time() - (int)$limit * 3600;
			}

			$conf =& Config::getInstance();
			$conf->set( 'count', count( $uris ) );

			foreach ( $uris as $uri ) {
				$info = load_config( $this->datadir . u( $uri ) );
				if ( ! is_array( $info ) ) {
					continue;
				}
				// Filtering by category
				if ( $category !== '' && $category !== $info['category'] && ( $category !== 'No' || $info['category'] !== '' ) ) {
					continue;
				}
				// Display item in limit time.
				if ( $limit && $info['last_modified'] <= $lim_time ) {
					continue;
				}
				// Hide visited page after check time
				if ( $vis && $info['last_modified'] <= $info['last_visit'] ) {
					continue;
				}
				$table[] = $info;
			}
			$this->_sort( $table );
		}
		return $table;
	}

	function getList()
	{
		if ( ! is_dir( $this->datadir ) ) {
			return array();
		}
		$files = array();
		if ( $handle = opendir( $this->datadir ) ) {
			while ( FALSE !== ( $file = readdir( $handle ) ) ) {
				if ( Validate::isUri( $uri = urldecode( $file ) ) ) {
					$files[] = $uri;
				}
			}
			closedir( $handle );
		}
		return $files;
	}

	function _sort( &$table )
	{
		$get  =& Request::getInstance( '_GET' );
		$sort  = $get->get( 'sort' );
		switch ( $sort ) {
		case 'last_modified'  :
		case 'uri'   :
		case 'size'  :
		case 'title' :
		case 'count' :
		case 'last_visit' :
			$rev = $get->get( 'rev' );
			break;
		case '_NO_ORDER' :
			return;
		default      :
			$get->set( 'rev',  $rev  = TRUE );
			$get->set( 'sort', $sort = 'last_modified' );
		}
		usort(
			$table,
			create_function( '$a, $b', 'return $a["' . $sort . '"] ' . ( $rev ? '<' : '>' ) . ' $b["' . $sort . '"];' )
		);
	}
}
