<?php
if ( PHP_SAPI !== 'cli' && basename( $_SERVER['SCRIPT_NAME'] ) === basename( __FILE__ ) ) { exit; }
/*
 Database encoding : UTF-8

 example : PostgreSQL
   $ psql -E UTF-8 wwwcheck
*/

$path = dirname( __FILE__ ) . '/';

require_once( $path . '../../init.inc.php' );
require_once( 'DB.php' );

// get items
$items  = array();
$handle = opendir( ITEM_DIR );
if ( $handle ) {
	while ( FALSE !== ( $file = readdir( $handle ) ) ) {
		if ( preg_match( '/^(?:ht|f)tps?/', $file ) ) {
			$items[] = ITEM_DIR . $file;
		}
	}
	closedir( $handle );
}

$db =& DB::connect( DSN );
if ( DB::isError( $db ) ) {
	exit ( $db->getMessage() );
}

$db->query( '
	CREATE TABLE wwwcheck (
	  uri           text PRIMARY KEY,
	  category      text,
	  charset       text,
	  count         int,
	  diff          text,
	  difflen       int,
	  encoding      text,
	  error         text,
	  header        text,
	  last_check    int,
	  last_modified int,
	  last_visit    int,
	  open_uri      text,
	  size          int,
	  status        text,
	  title         text )'
);


$db->query( 'BEGIN' );

foreach ( $items as $item ) {
	$data = load_config( $item );
//	$table1[] = $data;
	$data = array_map( array( $db, 'escapeSimple' ), $data );

	$data['diff'] = ! empty( $data['diff'] ) ? $data['diff'] : '';

	$db->query( "
		INSERT INTO wwwcheck (
		  category, charset, count, diff, difflen, encoding, error, header, last_check, last_modified, last_visit, open_uri, size, status, title, uri
		) VALUES(
		'" . ifsetor( $data['category'],     '' ) . "',
		'" . ifsetor( $data['charset'],      '' ) . "',
		"  . ifsetor( $data['count'],         0 ) . ",
		'" . ifsetor( $data['diff'],         '' ) . "',
		'" . ifsetor( $data['difflen'],       0 ) . "',
		'" . ifsetor( $data['encoding'],     '' ) . "',
		'" . ifsetor( $data['error'],        '' ) . "',
		'" . ifsetor( $data['header'],       '' ) . "',
		"  . ifsetor( $data['last_check'],    0 ) . ",
		"  . ifsetor( $data['last_modified'], 0 ) . ",
		"  . ifsetor( $data['last_visit'],    0 ) . ",
		'" . ifsetor( $data['open_uri'],     '' ) . "',
		"  . ifsetor( $data['size'],          0 ) . ",
		'" . ifsetor( $data['status'],       '' ) . "',
		'" . ifsetor( $data['title'],        '' ) . "',
		'" . ifsetor( $data['uri'],          '' ) . "')"
	);
}
$db->query( 'COMMIT' );

if ( PHP_SAPI !== 'cli' ) {
	require( LIBS_DIR . 'command.inc.php' );
	Command::redirect( '?mode=config', 'INFO_CREATE_DATABASE' );
	exit;
}

echo "database created.\n";

/**
// debug start

$db = DB::connect( ITEM_DIR );
if ( DB::isError( $db ) ) {
	exit ( $db->getMessage() );
}
$result = $db->query( 'SELECT * FROM wwwcheck' );
$table2 = sqlite_fetch_all( $result, SQLITE_ASSOC );
$db->disconnect();

foreach ( $table1 as $key => $item ) {
	ksort( $item );
	$table1[$key] = $item;
}
foreach ( $table2 as $key => $item ) {
	ksort( $item );
	$table2[$key] = $item;
}

file_put_contents( 'log_inc', print_r( $table1, TRUE ) );
file_put_contents( 'log_sql', print_r( $table2, TRUE ) );

//debug end.
**/

$db->disconnect();
