<?php
// for CGI
//   #!/usr/local/bin/php

// timer start
$_ts = microtime();

// input filtering
require( 'lib/baselib/inputfilter.inc.php' );

// read modules
require( 'init.inc.php' );
require( LIBS_DIR . 'command.inc.php' );
require( LIBS_DIR . 'filters.inc.php' );

Filters::getInstance( $filter_file );

// disable time limit
@set_time_limit( 0 );

// create configuration object
$conf =& Config::getInstance();

// prevent double starting
if ( is_file( $count_file ) && ( filectime( $count_file ) + 1000 > time() ) ) {
	exit( "This script has just execute. exit.\n" );
}

$uris = array();
$sapi = ! empty( $_SERVER['DOCUMENT_ROOT'] ) ? PHP_SAPI : 'cli';

// HTML for Apache DSO or CGI version
if ( $sapi !== 'cli' ) {
	// require HTTP authentication with PHP
	if ( ! $conf->isAuth() ) {
		include( VIEW_DIR . 'error_auth.tpl.php' );
		exit;
	}
	// POST only and not CSRF
	$post =& Request::getInstance( '_POST' );
	$uniq  = $post->get( 'uniq_id' );
	if ( ! $post->is_set( 'update' ) || ! $uniq || $conf->isCsrf( $uniq ) ) {
		Command::redirect();
		exit;
	}

	// enable implicit flush.
	ob_implicit_flush( 1 );

	// ignore user abort
	ignore_user_abort( 1 );

	// clear output buffers
	while ( ob_get_level() ) { ob_end_flush(); }

	echo "<html><head><title>Check...</title></head><body>\n<pre>\n";
}
else {
	// for PHP CLI
	$argc = ! empty( $_SERVER['argc'] ) ? (int)$_SERVER['argc'] : (int)ifsetor( $argc, 0 );
	$argv = ! empty( $_SERVER['argv'] ) ?      $_SERVER['argv'] :      ifsetor( $argv, array() );

	// get items from commandline args
	if ( $argc > 1 ) {
		for ( $i = 1; $i < $argc; ++$i ) {
			if ( Validate::isUri( $argv[$i] ) ) {
				$uris[] = $argv[$i];
			}
		}
	}
}
p( "Start Time: " . date( "Y/m/d H:i:s" ) . "\n" );
p( $conf->get( 'use-proxy' ) ? "Using Proxy : " . $conf->get( 'proxy' ) . "\n\n" : "\n" );

if ( ! $uris ) {
	// get all items
	$reader =& Data::getReader( SAVE_HANDLE, $dummy = '' );
	$uris = $reader->getList();
	if ( ! $uris ) {
		exit( "Could not open data file or find item.\n" );
	}
}
// shuffle URI array
shuffle( $uris );

// initialize count and count file
if ( is_file( $count_file ) ) {
	unlink( $count_file );
}
file_put_contents( $count_file, count( $uris ) );
touch( $count_file, 0 );

$count   = 0;
$pids    = array();
$process = 5;

if ( extension_loaded( 'pcntl' ) && ( $sapi === 'cli' || $sapi === 'cgi' ) ) {

	foreach ( $uris as $uri ) {
		++$count;
		$pid = pcntl_fork();
		if ( $pid === -1 ) {
			exit( "could not fork.\n" );
		}
		else if ( $pid ) {
			// parent process
			$pids[ $pid ] = TRUE;
			if ( next( $uris ) === FALSE ) {
				$process = 1;
			}
			while ( count( $pids ) >= $process ) {
				unset( $pids[ pcntl_waitpid( -1, $status, WUNTRACED ) ] );
			}
		}
		else {
			// child process
			p( Command::checkAll( $count, $uri, $count_file ) );
			exit;
		}
	}
}
else if ( $php = Command::findPhpCli( $conf->get( 'php_command' ) ) ) {

	$check_php = SELF_DIR . 'check.php';
	if ( ! is_file( $check_php ) ) {
		exit( "check.php not found. file :" . $check_command . "\n" );
	}
	foreach ( $uris as $uri ) {
		// execute php cli by popen()
		$c = sprintf( '%s %s %d %s 2>&1', escapeshellcmd( $php ), escapeshellarg( $check_php ), (int)++$count, escapeshellarg( $uri ) );
		$p = popen( $c, 'r' );
		if ( $p === FALSE ) {
			p( "could not execute popen. command : " . $c . "\n" );
			continue;
		}
		stream_set_blocking( $p, FALSE );
		$pids[] = $p;
		if ( next( $uris ) === FALSE ) {
			$process = 1;
		}
		while ( count( $pids ) >= $process ) {
			foreach ( $pids as $n => $ph ) {
				p( stream_get_contents( $ph ) );

				// Clear output buffer
				while ( ob_get_level() ) { ob_end_flush(); }

				if ( feof( $ph ) ) {
					pclose( $ph );
					unset( $pids[ $n ] );
				}
			}
			usleep( 100000 );
		}
	}
}
else {
	foreach ( $uris as $uri ) {
		p( Command::checkAll( ++$count, $uri, $count_file ) );
	}
}
// delete count file
if ( is_file( $count_file ) ) {
	unlink( $count_file );
}

// update configuration file
$conf->set( 'last-modified', time() );

// end time
p( "\n--\n" );
p( "End Time: " . date( "Y/m/d H:i:s" ) . "\n" );

// timer end, print message
diff_time( $_ts );
printf( "END. %f Seconds\n", diff_time() );

if ( $sapi !== 'cli' ) {
	echo "</pre>\n<div><a href=\"./\">Go to Result Page</a></div></body></html>";
}

$vacuum_file = SELF_DIR . 'misc/' . SAVE_HANDLE . '/vacuum.php';
if ( is_file( $vacuum_file ) ) {
	include( $vacuum_file );
}
