<?php if ( basename( $_SERVER['SCRIPT_NAME'] ) === basename( __FILE__ ) ) { exit; } ?>
<h1><?php p( $page_title ) ?> 更新チェック実行、設定変更ページ</h1>
<div class="main">

<div class="menu">
<div class="move">
<h2>メニュー</h2>
<a href="<?php p( $top_page ) ?>">一覧に戻る</a>
<a class="selectconf" href="<?php p( $config_page ) ?>">設定変更</a>
<a href="<?php p( $status_page ) ?>">ステータス一覧</a>
<a href="<?php p( $filter_page ) ?>">フィルタ編集</a>
<?php if ( $last ) : ?>
<div class="checkdate">最終チェック日時: <span class="date"><?php p( $last ) ?></span></div>
<?php endif ?>
</div>

<div class="submenu">
<h2>設定変更</h2>
<a class="<?php p_if( $class === '',  'select' ) ?>conf" href="<?php p( $self ) ?>">アイテムの追加、更新チェック</a>
<a class="<?php p_if( $class === 'c', 'select' ) ?>conf" href="<?php p( $self . '&c=c' ) ?>">カテゴリ設定</a>
<a class="<?php p_if( $class === 'd', 'select' ) ?>conf" href="<?php p( $self . '&c=d' ) ?>">表示・デフォルト値設定</a>
<a class="<?php p_if( $class === 'p', 'select' ) ?>conf" href="<?php p( $self . '&c=p' ) ?>">ユーザ名・パスワード</a>
<a class="<?php p_if( $class === 'n', 'select' ) ?>conf" href="<?php p( $self . '&c=n' ) ?>">Proxy 設定</a>
<a class="<?php p_if( $class === 'e', 'select' ) ?>conf" href="<?php p( $self . '&c=e' ) ?>">コマンドパス</a>
</div>
</div>
<div class="list">
<?php if ( $message ) : ?><div class="info"><?php p( $message ) ?></div><?php endif ?>

<?php if ( $uri !== 'http://' || $class === '' ) : ?>
<h3>更新チェックアイテムの追加</h3>
<div class="set">
<div>追加したい URI を入力してください。</div>
<form action="<?php p( $self ) ?>" method="post">
 <div>
 <input type="hidden" name="uniq_id" value="<?php p( $uniq_id ) ?>" />
 <input class="textbox" type="text" tabindex="1" accesskey="a" name="additem" value="<?php p( $uri ) ?>" />
 <input class="button" type="submit" tabindex="2" value="追加" accesskey="i" />
 </div>
</form>
</div>
<?php endif ?>
<?php if ( $uri === 'http://' ) : ?>
<?php 	if ( $class === '' ) : ?>
<h3>更新チェック実行</h3>
<div class="set">
<form action="update.php" method="post">
 <div>
 <input type="hidden" name="uniq_id" value="<?php p( $uniq_id ) ?>" />
 <input type="submit" tabindex="3" name="update" value="更新チェック実行" accesskey="u" />
 </div>
</form>
</div>
<?php 	endif ?>
<?php 	if ( $class === 'd' ) : ?>
<h3>表示・デフォルト値設定</h3>
<p>表示設定、デフォルト値の設定を行います。</p>
<div class="set">
<form action="<?php p( $self ) ?>" method="post">
 <h4>タイトル</h4>
 <div class="set2">
  <div>上部に表示されるタイトルを変更できます。</div>
  <div><input class="textbox" type="text" tabindex="1" name="title" value="<?php p( $page_title ) ?>" /></div>
 </div>
 <h4>スタイル設定</h4>
 <div class="set2">
  <div>以下のスタイルが選択できます。</div>
  <div>
   <select name="css" tabindex="2">
<?php foreach ( $styles as $file => $name ) : ?>
    <option <?php p_if( $curcss === $file, 'selected="selected" ', TRUE ) ?>value="<?php p( $file ) ?>"><?php p( $name ) ?></option>
<?php endforeach ?>
   </select>
  </div>
 </div>
 <h4>表示する差分文字数(デフォルト値)</h4>
 <div class="set2">
  <div>更新内容の差分表示での最大表示文字数を設定できます。0 に設定すると差分内容を表示しません。</div>
  <div><input class="textbox" type="text" tabindex="3" name="diff_count" value="<?php p( $diff_count ) ?>" /></div>
 </div>
 <h4>表示期間(デフォルト値)</h4>
 <div class="set2">
  <div>対象のページが更新されてから、指定された期間を越えた項目を隠します。</div>
  <div>
  <select name="lim" tabindex="4">
   <option value="0"<?php   p_if( $limit ===   0, ' selected="selected"', TRUE ) ?>>無期限</option>
   <option value="1"<?php   p_if( $limit ===   1, ' selected="selected"', TRUE ) ?>>1時間</option>
   <option value="2"<?php   p_if( $limit ===   2, ' selected="selected"', TRUE ) ?>>2時間</option>
   <option value="4"<?php   p_if( $limit ===   4, ' selected="selected"', TRUE ) ?>>4時間</option>
   <option value="8"<?php   p_if( $limit ===   8, ' selected="selected"', TRUE ) ?>>8時間</option>
   <option value="16"<?php  p_if( $limit ===  16, ' selected="selected"', TRUE ) ?>>16時</option>
   <option value="24"<?php  p_if( $limit ===  24, ' selected="selected"', TRUE ) ?>>1日</option>
   <option value="48"<?php  p_if( $limit ===  48, ' selected="selected"', TRUE ) ?>>2日</option>
   <option value="96"<?php  p_if( $limit ===  96, ' selected="selected"', TRUE ) ?>>4日</option>
   <option value="168"<?php p_if( $limit === 168, ' selected="selected"', TRUE ) ?>>1週間</option>
   <option value="336"<?php p_if( $limit === 336, ' selected="selected"', TRUE ) ?>>2週間</option>
  </select>
  </div>
 </div>
 <h4>訪問後の項目(デフォルト値)</h4>
 <div class="set2">
  <div>対象のページを訪れた場合、対象のページが更新されるまで隠します。ログインしていない場合は項目は隠しません。</div>
  <div>
   <select name="vis" tabindex="5">
    <option value="">項目を隠さない</option>
    <option value="1" <?php p_if( $visit, 'selected="selected"', TRUE ) ?>>項目を隠す</option>
   </select>
  </div>
 </div>
 <div>
  <input type="hidden" name="uniq_id" value="<?php p( $uniq_id ) ?>" />
  <input type="submit" class="button" tabindex="6" name="defaultsetting" value="設定を保存" accesskey="k" />
 </div>
</form>
</div>
<?php 	endif // if ( $class === 'd' ) ?>
<?php 	if ( $class === 'c' ) : ?>
<form method="post" action="<?php p( $self ) ?>">
<h3>カテゴリの追加 :</h3>
<div class="set">
<div>分類を行うカテゴリを追加します。URI をカテゴリに所属させると、結果表示でカテゴリによるフィルタを行うことができます。</div>
<div>
  <input type="hidden" name="uniq_id" value="<?php p( $uniq_id ) ?>" />
  <input class="textbox" type="text" tabindex="6" name="name" value="" />
  <input class="button" type="submit" tabindex="7" name="addcategory" value="追加" />
</div>
</div>
</form>
<?php 		if ( $categories ) : ?>
<h3>カテゴリ一覧、削除 :</h3>
<div class="set">
 <div>登録済みカテゴリ一覧です。もし、間違ってカテゴリを登録した場合は削除してください。
      カテゴリを削除した場合、削除したカテゴリに含まれていた項目は「未分類」のカテゴリに移動します。</div>
 <table class="set2" summary="カテゴリ一覧・削除" cellpadding="0">
 <tbody>
<?php 		foreach ( $categories as $id => $category ) : ?>
 <tr>
 <td class="underline">
  <form method="post" action="<?php p( $self ) ?>">
   <div>
   <input type="hidden" name="uniq_id" value="<?php p( $uniq_id ) ?>" />
   <input type="hidden" name="id" value="<?php p( $id ) ?>" />
   <input type="text" size="30" name="name" value="<?php p( $category ) ?>" />
   <input type="submit" name="altercategory" value="変更" />
   <input type="submit" name="upcategory" value="上へ" />
   <input type="submit" name="downcategory" value="下へ" />
   </div>
  </form>
 </td>
 <td>
  <form method="post" action="<?php p( $self ) ?>">
   <div>
   <input type="hidden" name="uniq_id" value="<?php p( $uniq_id ) ?>" />
   <input type="hidden" name="id" value="<?php p( $id ) ?>" />
   <input type="submit" name="delcategory" value="削除" />
   </div>
  </form>
 </td>
 </tr>
<?php 		endforeach ?>
 </tbody>
 </table>
</div>
<?php 		endif // if ( $categories ) ?>
<?php 	endif // if ( $class === 'c' )?>
<?php 	if ( $class === 'p' ) : ?>
<h3>ユーザ名とパスワード</h3>
<div class="set">
<div>このページにアクセスするときに認証が必要な場合は設定してください。
     設定後、HTTP 認証を行わないと、このページにアクセスできなくなります。
     一度設定を行うと、設定ファイルを削除しない限り、認証に成功しないとこのページにはアクセスできませんので注意してください。</div>
<form method="post" action="<?php p( $self ) ?>">
 <table class="set2" summary="ユーザ名とパスワード設定">
  <tbody>
  <tr><td class="td">ユーザ名 :  </td><td><input class="textbox" type="text" name="user" value="<?php p( $user ) ?>" /></td></tr>
  <tr><td class="td">パスワード :</td><td><input class="textbox" type="password" name="pass1" value="" /></td></tr>
  <tr><td class="td">確認入力 :  </td><td><input class="textbox" type="password" name="pass2" value="" /></td></tr>
  <tr><td colspan="2" class="td">
       <input type="hidden" name="uniq_id" value="<?php p( $uniq_id ) ?>" />
       <input type="submit" name="chpass" value="ユーザ名とパスワードを変更" />
      </td></tr>
  </tbody>
</table>
</form>
</div>
<?php 	endif // if ( $class === 'p' ) ?>
<?php 	if ( $class === 'n' ) : ?>
<h3>Proxy 設定</h3>
<div class="set">
<form method="post" action="<?php p( $self ) ?>">
 <div><input type="hidden" name="uniq_id" value="<?php p( $uniq_id ) ?>" /></div>
 <div>Proxy サーバの設定が必要な場合は「Proxy を使用」にチェックを入れ、Proxy サーバの設定を行ってください。
      Proxy サーバの設定は、「Proxy サーバのホスト名:ポート番号」で入力してください。例: proxy.example.com:8080</div>
 <table class="set2" summary="Proxy 設定">
  <tbody>
  <tr><td class="td">Proxy を使用 :</td>
      <td><input type="checkbox" name="use_proxy" value="1" <?php p_if( $use_proxy, 'checked="checked" ', TRUE ) ?>/></td></tr>
  <tr><td class="td">Proxy サーバ :</td>
      <td><input class="textbox" type="text" name="proxy" value="<?php p( $proxy ) ?>" /></td></tr>
  <tr><td></td>
      <td class="td"><input type="submit" name="setproxy" value="設定を保存" /></td></tr>
  </tbody>
 </table>
</form>
</div>
<?php 	endif // if ( $class === 'n' ) ?>
<?php 	if ( $class === 'e' ) : ?>
<h3>コマンドパス設定</h3>
<div class="set">
<form method="post" action="<?php p( $self ) ?>">
 <h4>コマンドライン(CLI)版 PHP パス</h4>
 <div class="set2">
  <div>更新チェック時に使用するコマンドライン(CLI)版の PHP のパスをを指定して下さい。</div>
  <div>例: <code>/usr/local/bin/php</code></div>
  <div><input class="textbox" type="text" tabindex="1" name="php_command" value="<?php p( $php_cli ) ?>" /></div>
 </div>
 <h4>diff コマンドパス</h4>
 <div class="set2">
  <div>diff コマンドが使用できる場合はそのパスを指定して下さい。差分取得が速くなります。</div>
  <div>例: <code>/usr/bin/diff</code></div>
  <div><input class="textbox" type="text" tabindex="2" name="diff_command" value="<?php p( $diff_comm ) ?>" /></div>
 </div>
 <div>
  <input type="hidden" name="uniq_id" value="<?php p( $uniq_id ) ?>" />
  <input class="button" type="submit" tabindex="3" name="commandpath" value="設定を保存" />
 </div>
</form>
</div>
<?php 	endif // if ( $class= 'e' ) ?>
<?php endif ?>
</div>
</div>
