<?php
if ( basename( $_SERVER['SCRIPT_NAME'] ) === basename( __FILE__ ) ) { exit; }

$order_name = array(
	''  => '昇順',
	'1' => '降順',
);

$sort_name = array(
	'last_modified' => '最終更新日時',
	'title'         => 'タイトル',
	'uri'           => 'URI',
	'count'         => 'カウント数',
	'last_visit'    => '最終訪問日時'
);

$limit_time = array(
	0   => '無期限',
	1   => '1時間',
	2   => '2時間',
	4   => '4時間',
	8   => '8時間',
	16  => '16時間',
	24  => '1日',
	48  => '2日',
	96  => '4日',
	168 => '1週間',
	336 => '2週間'
);

?>
<h1><?php p( $page_title ) ?></h1>

<div class="main">

<div class="menu">
<div class="submenu">
 <h2>カテゴリ</h2>
 <a <?php p_if( $category === '', 'class="selected" ', TRUE ) ?>href="<?php p( $query ) ?>">全表示</a>
<?php foreach ( $categories as $key => $val ) : ?>
 <a <?php p_if( $category === (string)$key, 'class="selected" ', TRUE ) ?>href="<?php p( $query ) ?>&amp;cat=<?php p( $key ) ?>"><?php p( $val ) ?></a>
<?php endforeach ?>
 <a <?php p_if( $category === 'No', 'class="selected" ', TRUE ) ?>href="<?php p( $query ) ?>&amp;cat=No">未分類</a>
</div>

<div class="submenu">
 <h2>フィルタ</h2>
 <form class="menu_conf" action="<?php p( $self ) ?>" method="get">
 <div>
 <input type="hidden" name="cat" value="<?php p( $category ) ?>" />
 <label class="item" accesskey="s">ソート方法 :
 <select name="sort" tabindex="1">
<?php foreach ( $sort_types as $key => $select ) : ?>
  <option class="selectbox" value="<?php p( $key ) ?>"<?php p_if( $select, ' selected="selected"', TRUE ) ?>><?php p( $sort_name[$key] ) ?></option>
<?php endforeach ?>
 </select>
 </label>
 <label accesskey="o" class="item">
 <select name="rev" tabindex="2">
<?php foreach ( $order as $key => $select ) : ?>
  <option value="<?php p( $key ) ?>"<?php p_if( $select, ' selected="selected"', TRUE ) ?>><?php p( $order_name[$key] ) ?></option>
<?php endforeach ?>
 </select>
 </label>
 <label class="item" accesskey="d">差分表示 :
  <input type="text" name="size" size="4" tabindex="3" value="<?php p( $size ) ?>" />文字
 </label>
 <label class="item" accesskey="l">表示期間 :
 <select name="lim" tabindex="4">
<?php foreach ( $limits as $key => $select ) : ?>
  <option value="<?php p( $key ) ?>"<?php p_if( $select, ' selected="selected"', TRUE ) ?>><?php p( $limit_time[$key] ) ?></option>
<?php endforeach ?>
 </select>
 </label>
<?php if ( $auth ) : ?>
 <label class="item" accesskey="u">訪問後の項目 :
 <select name="vis" tabindex="5">
  <option value="">項目を隠さない</option>
  <option value="1" <?php p_if( $visit, 'selected="selected"', TRUE ) ?>>項目を隠す</option>
 </select>
 </label>
<?php endif ?>
 <input class="button" accesskey="k" type="submit" tabindex="6" value="決定" />
 </div>
 </form>
</div>

<div class="conf">
 <h2>設定・更新チェック</h2>
  <div class="checkdate">最終チェック日時 : <span class="date"><?php p( $last ) ?></span></div>
  <a href="<?php p( $to_config ) ?>">設定・更新チェック</a>
</div>
</div><!-- /menu -->

<div class="list">
<?php if ( $message ) : ?>
<div class="info"><?php p( $message ) ?></div>
<?php endif // $message ?>
<?php if ( $items ) : ?>
<ol>
<?php 	foreach ( $items as $a ) : ?>
<li>
<?php		if ( $auth ) : ?>
 <span class="date"><?php p( $a['date'] ) ?></span><?php if ( $a['flag'] ) : ?> <strong>*</strong> <?php endif ?>
 <a class="link" title="<?php p( $a['title'] ) ?> へ移動" href="<?php p( $to_link . u( $a['uri'] ) . '&' . $a['lflag'] ) ?>"><?php p( $a['title'] ) ?></a>
 <a class="conf" title="<?php p( $a['title'] ) ?> 設定" href="<?php p( $to_setting . u( $a['uri'] ) ) ?>">[設定]</a>
<?php 			if ( $a['stat'] !== 'OK' && $a['stat'] !== 'Not Modified' ) : ?>
 <code class="opt">[<strong><?php p( $a['stat'] ) ?></strong>]</code>
<?php 			endif ?>
 <span class="opt">count:<?php p( $a['count'] ) ?> visit:<span class="date"><?php p( $a['last'] ) ?></span> check:<span class="date"><?php p( $a['check'] ) ?></span></span>
<?php		else : // $auth ?>
 <span class="date"><?php p( $a['date'] ) ?></span>
 <a class="link" title="<?php p( $a['title'] ) ?> へ移動" href="<?php p( $to_link . u( $a['uri'] ) . '&' . $a['lflag'] ) ?>"><?php p( $a['title'] ) ?></a>
 <span class="opt">count:<?php p( $a['count'] ) ?> check:<span class="date"><?php p( $a['check'] ) ?></span>
 </span>
<?php		endif // $auth ?>
<?php 		if ( $a['diff'] ) : ?>
 <blockquote class="disp">
 <div><?php p_ex( $a['diff'] ) ?>
<?php 			if ( $a['dflag'] ) : ?>...
 <div>( ...省略されました... <?php p_if( ! $auth, ')' ) ?>
<?php 				if ( $auth ) : ?>
 <strong><a title="<?php p( $a['title'] ) ?>設定" href="<?php p( $to_setting . u( $a['uri'] ) ) ?>">[設定]</a></strong> )</div>
<?php				endif // $auth ?>
<?php 			endif // $a['dflag'] ?></div>
 </blockquote>
<?php 		endif // $a['diff'] ?>
</li>
<?php 	endforeach ?>
</ol>
<?php else : // $items ?>
<div class="info">条件に一致する項目がありません。</div>
<?php endif // $items ?>
</div><!-- /list -->

</div><!-- /main -->
