<?php if ( basename( $_SERVER['SCRIPT_NAME'] ) === basename( __FILE__ ) ) { exit; } ?>
<h1><?php p( $title ) ?> 設定/詳細 (<?php p( $page_title ) ?> 設定)</h1>

<div class="main">

<div class="menu">
<div>
<h2>メニュー</h2>
<a href="<?php p( $top_page )    ?>">一覧に戻る</a>
<a href="<?php p( $config_page ) ?>">全体設定</a>
<a href="<?php p( $filter_page ) ?>">フィルタ編集</a>
</div>
<div>
<h2>差分表示</h2>
<a class="<?php p( $tag ? 'conf' : 'selectconf' ) ?>" href="<?php p( $self_page . '&tag=0&log=' . $log ) ?>">HTML タグを除く</a>
<a class="<?php p( $tag ? 'selectconf' : 'conf' ) ?>" href="<?php p( $self_page . '&tag=1&log=' . $log ) ?>">HTML タグを含める</a>
</div>
<div>
<h2>HTML表示</h2>
<?php foreach ( $logs as $num => $time ) : ?>
<a class="<?php p( $num === $log ? 'selectconf' : 'conf' ) ?>" href="<?php p( $self_page . '&tag=' . (int)$tag . '&log=' . (int)$num ) ?>"><?php p( $time . ( $num ? '' : '(最新)' ) ) ?></a>
<?php endforeach ?>
</div>
<div>
<h2>更新チェック</h2>
<a href="<?php p( $setting_page . '&update=' . u( $uri ) ) ?>">更新チェックの実行</a>
</div>
</div>

<div class="list">

<?php if ( $message ) : ?>
<div class="info"><?php p( $message ) ?></div>
<?php endif ?>

<form action="<?php p( $setting_page ) ?>" method="post">
<table class="set" summary="<?php p( $title ) ?> 設定/詳細">
<tbody>
 <tr><th class="td">URI : </th><td><input class="textbox" tabindex="1" type="text" name="to_uri" value="<?php p( $uri ) ?>" /></td></tr>
 <tr><th class="td">タイトル : </th><td><input class="textbox" tabindex="2" type="text" name="title" value="<?php p( $title ) ?>" /></td></tr>
 <tr><th class="td">開く URI : </th><td><input class="textbox" tabindex="3" type="text" name="open_uri" value="<?php p( $open_uri ) ?>" /></td></tr>
 <tr><th class="td">訪問回数 : </th><td><input class="textbox" tabindex="4" type="text" name="count" value="<?php p( $count ) ?>" /></td></tr>
 <tr><th class="td">カテゴリ : </th><td><select name="category">
  <option value="">未分類</option>
<?php foreach ( $categories as $key => $val ) : ?>
  <option value="<?php p( $key ) ?>"<?php p_if( (string)$category === (string)$key, ' selected="selected"' ) ?>><?php p( $val ) ?></option>
<?php endforeach ?></select></td></tr>
 <tr><th class="td">文字コード : </th><td><select name="encoding">
<?php foreach ( $encodings as $encode => $val ) : ?>
  <option value="<?php p( $encode ) ?>"<?php p_if( $encoding === $encode, ' selected="selected"') ?>><?php p( $encode ) ?></option>
<?php endforeach ?></select> ※文字化けする場合に指定してください。<br />
<?php if ( $charset ) : ?>判定した文字コード(<?php p( $charset ) ?>)<?php endif ?>
</td></tr>
 <tr><th align="center" colspan="2">
  <input type="hidden" name="uniq_id" value="<?php p( $uniq_id ) ?>" />
  <input type="hidden" name="setting" value="<?php p( $uri ) ?>" />
  <input type="submit" tabindex="5" name="alter" value="変更" />
  &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
  <input type="submit" tabindex="6" name="delete" value="削除" />
 </th>
 </tr>
</tbody>
</table>
</form>

<h2>情報表示</h2>
<table class="set" summary="情報表示">
<tbody>
 <tr><th class="td">ステータス :</th><td><?php p( $status ) ?></td></tr>
 <tr><th class="td">最終更新日時 :</th><td><span class="date"><?php p( $last_modified ) ?></span></td></tr>
 <tr><th class="td">最終訪問日時 :</th><td><span class="date"><?php p( $last_visit    ) ?></span></td></tr>
 <tr><th class="td">チェック日時 :</th><td><span class="date"><?php p( $check_date    ) ?></span></td></tr>
 <tr><th class="td">サイズ : </th><td><?php p( $size ) ?></td></tr>
<?php if ( $filters ) : ?>
 <tr><th class="td"><div>フィルタ :</div></th><td>
 <div class="disp">
<?php 	foreach ( $filters as $filter ) : ?>
 <code><?php p( $filter ) ?></code><br />
<?php 	endforeach ?>
 </div>
 </td></tr>
<?php endif ?>
 <tr><th class="td">HTTP Header :</th><td><div class="disp"><code><?php br_p( $header ) ?></code></div></td></tr>
</tbody>
</table>

<h2>差分表示 (HTML タグを<?php p( $tag ? '含む' : '除く' ) ?> )</h2>
<?php foreach ( $diffs as $n => $diff ) : ?>
<div class="opt"><?php p( $n ) ?>世代前の比較 ( <?php p( $mtime[$n] ) ?> )</div>
<?php 	if ( $diff ) : ?>
<div class="disp"><?php p_ex( $diff ) ?></div>
<?php	else : ?>
<div>追加された差分はありません。</div>
<?php 	endif ?>
<?php endforeach ?>

<h2>HTML ソース (<?php p( $logs[$log] ) ?>)</h2>
<div class="disp">
<?php br_p( $source ) ?>
</div>
</div>

</div>
