<?php
if ( basename( $_SERVER['SCRIPT_NAME'] ) === basename( __FILE__ ) ) { exit; }

$get =& Request::getInstance( '_GET' );

$size = $get->get( 'size' );
if ( $size === FALSE ) {
	$diffcount = $conf->get( 'diff_count' );
	$size      = $diffcount !== FALSE  ? (int)$diffcount : 200;
}
else {
	$size  = (int)$size;
}
$sort     = $get->get( 'sort', '' );
$visit    = (bool)$get->get( 'vis' );
$reverse  = (bool)$get->get( 'rev' );
$limit    =  (int)$get->get( 'lim', 24 );
$category = $get->get( 'cat',  '' );

$self       = WEB_SELF;
$to_link    = $self . '?go=';
$to_config  = $self . '?mode=config';
$to_setting = $self . '?mode=setting&uri=';
$query      = $self . '?sort=' . $sort . '&rev=' . ( $reverse ? 1 : 0 ) . '&size=' . (int)$size . '&vis=' . ( $visit ? 1 : 0 ) . '&lim='  . (int)$limit;

$last = $conf->get( 'last-modified' );
$last = $last ? date( "Y/m/d H:i:s", $last ) : '----/--/--';

// Categories
$cate =& Category::getInstance();
$categories = $cate->get();

// Sort Order
$order = array(
	''  => ! $reverse,
	'1' =>   $reverse
);

// Limit Time
$limits = array(
	0   => FALSE, 1   => FALSE, 2   => FALSE, 4   => FALSE,
	8   => FALSE, 16  => FALSE, 24  => FALSE, 48  => FALSE,
	96  => FALSE, 168 => FALSE, 336 => FALSE,
);
if ( isset( $limits[$limit] ) ) {
	$limits[$limit]	= TRUE;
}
else {
	$limits[24]	= TRUE;
}

// Sort Types
$sort_types = array(
	'last_modified' => FALSE,
	'title'         => FALSE,
	'uri'           => FALSE,
	'count'         => FALSE,
	'last_visit'    => FALSE,
);
if ( isset( $sort_types[$sort] ) ) {
	$sort_types[$sort] = TRUE;
}

$items = array();
foreach ( $data as $info ) {
	$diff  = '';
	$dflag = FALSE;
	if ( $size ) {
		$diff = (string)ifsetor( $info['diff'] );
		$len  = ifsetor( $info['difflen'] );
		if ( $len === FALSE ) {
			$len = mb_strlen( $diff );
		}
		if ( $len > $size ) {
			$diff  = mb_substr( $diff, 0, $size );
			$dflag = TRUE;
		}
	}
	$last_c = (int)ifsetor( $info['last_check'],    0 );
	$last_v = (int)ifsetor( $info['last_visit'],    0 );
	$last_m = (int)ifsetor( $info['last_modified'], 0 );

	$items[] = array(
		'title' => $info['title'],
		'uri'   => $info['uri'],
		'lflag' => date( 'mdHi', $last_m ),
		'flag'  => (bool)( $last_m > $last_v ),
		'check' => ( $last_c ? date( "m/d H:i",     $last_c ) : '--/-- --:--'         ),
		'last'  => ( $last_v ? date( 'm/d H:i',     $last_v ) : '--/-- --:--'         ),
		'date'  => ( $last_m ? date( 'Y/m/d H:i:s', $last_m ) : '----/--/-- --:--:--' ),
		'count' => (int)ifsetor( $info['count'], 0 ),
		'stat'  => ifsetor( $info['status'], 'OK' ),
		'dflag' => (bool)$dflag,
		'diff'  => $diff,
	);
}
