<?php
if ( basename( $_SERVER['SCRIPT_NAME'] ) === basename( __FILE__ ) ) { exit; }

$get =& Request::getInstance( '_GET' );

$tag = (bool)$get->get( 'tag', FALSE );
$log =  (int)$get->get( 'log', FALSE );

$info     = $data[0];
$uri      = ifsetor( $info['uri'],      '' );
$title    = ifsetor( $info['title'],    '' );
$open_uri = ifsetor( $info['open_uri'], '' );
$status   = ifsetor( $info['status'],   '' );
$encoding = ifsetor( $info['encoding'], '' );
$charset  = ifsetor( $info['charset'],  '' );
$category = ifsetor( $info['category'], '' );
$header   = ifsetor( $info['header'],   '' );

$count    = (int)ifsetor( $info['count'], '' );
$size     = isset( $info['size'] ) ? number_format( $info['size'] ) . " Bytes" : '';

$top_page     = WEB_SELF;
$config_page  = $top_page . '?mode=config';
$setting_page = $top_page . '?mode=setting';

$encoded_uri  = u( $uri );
$self_page    = $top_page . '?mode=setting&uri=' . $encoded_uri;
$filter_page  = $top_page . '?mode=filter&link=' . $encoded_uri;
$logfile      = LOGS_DIR . $encoded_uri;

$viewlog      = ( $log && is_readable( $logfile . '.' . $log ) ) ? $logfile . '.' . $log : $logfile;
if ( $logfile === $viewlog ) {
	$log = 0;
}

$last_visit   = ! empty( $info['last_visit'] )
	? date( 'Y/m/d H:i:s', $info['last_visit'] )
	: '----/--/-- --:--:--';

$last_modified = ! empty( $info['last_modified'] ) && $info['last_modified'] != -1
	? date( 'Y/m/d H:i:s', $info['last_modified'] )
	: '----/--/-- --:--:--';

$check_date = ! empty( $info['last_check'] ) && $info['last_check'] != -1
	? date( 'Y/m/d H:i:s', $info['last_check'] )
	: '----/--/-- --:--:--';

// Encodings
$enc =& Encodings::getInstance();
$encodings = $enc->getEncodings();

// Categories
$cat =& Category::getInstance();
$categories = $cat->get();

// Filters
$fil =& Filters::getInstance();
$filters = array();
foreach ( $fil->getRawFilters() as $fil_uri => $pattern ) {
	if ( preg_match( '/' . preg_quote( $fil_uri, '/' ) . '/i', $uri ) ) {
		$filters = array_merge( $filters, $pattern );
	}
}

// diff
$period  = 0;
$diffs   = array();
$logs[0] = date( 'Y/m/d H:i', filemtime( $logfile ) );
while ( is_readable( $logfile . '.' . ++$period ) ) {
	$new_file = $logfile . ( ( $period > 1 ) ? '.' . ( $period - 1 ) : '' );
	$old_file = $logfile . '.' . $period;
	$periods  = ( ( $period > 1 ) ? ( $period - 1 ) . '-' : '' ) . $period;
	$diffs[$periods] = Command::diffFile( $old_file , $new_file, $tag );
	$mtime[$periods] = date( 'Y/m/d H:i:s', filemtime( $old_file ) ) . " | " . date( 'Y/m/d H:i:s', filemtime( $new_file ) );
	$logs[$period]   = date( 'Y/m/d H:i',   filemtime( $old_file ) );
}

// HTML Source
$source = '';
if ( is_readable( $viewlog ) ) {
	$source = preg_replace(
		array( "/\n+/", "/[ \t]+/" ),
		array( "\n",    " " ),
		trim( file_get_contents( $viewlog ) )
	);
}
